Index: issm/trunk/src/m/solve/solve.py
===================================================================
--- issm/trunk/src/m/solve/solve.py	(revision 25994)
+++ issm/trunk/src/m/solve/solve.py	(revision 26744)
@@ -1,5 +1,4 @@
 from datetime import datetime
 import os
-import shutil
 
 from ismodelselfconsistent import ismodelselfconsistent
@@ -16,29 +15,31 @@
     Usage:
         md = solve(md, solutionstring, varargin)
-    
+
     where varargin is a list of paired arguments of string OR enums
 
     Solution types available comprise:
-    - 'Stressbalance'      or 'sb'
-    - 'Masstransport'      or 'mt'
-    - 'Thermal'            or 'th'
-    - 'Steadystate'        or 'ss'
-    - 'Transient'          or 'tr'
-    - 'Balancethickness'   or 'mc'
-    - 'Balancevelocity'    or 'bv'
-    - 'BedSlope'           or 'bsl'
-    - 'SurfaceSlope'       or 'ssl'
-    - 'Hydrology'          or 'hy'
-    - 'DamageEvolution'    or 'da'
-    - 'Gia'                or 'gia'
-    - 'Esa'                or 'esa'
-    - 'Sealevelrise'       or 'slr'
-    - 'Love'               or 'lv'
+    - 'Stressbalance'        or 'sb'
+    - 'Masstransport'        or 'mt'
+    - 'Oceantransport'       or 'oceant'
+    - 'Thermal'              or 'th'
+    - 'Steadystate'          or 'ss'
+    - 'Transient'            or 'tr'
+    - 'Balancethickness'     or 'mc'
+    - 'BalancethicknessSoft' or 'mcsoft'
+    - 'Balancevelocity'      or 'bv'
+    - 'BedSlope'             or 'bsl'
+    - 'SurfaceSlope'         or 'ssl'
+    - 'Hydrology'            or 'hy'
+    - 'DamageEvolution'      or 'da'
+    - 'Gia'                  or 'gia'
+    - 'Love'                 or 'lv'
+    - 'Esa'                  or 'esa'
+    - 'Sampling'             or 'smp'
 
     Extra options:
-    - loadonly         : does not solve. only load results
-    - runtimename      : true or false (default is true), makes name unique
-    - checkconsistency : 'yes' or 'no' (default is 'yes'), ensures checks on 
-                         consistency of model
+    - loadonly         : do not solve, only load results
+    - runtimename      : true or false (default is true); makes name unique
+    - checkconsistency : 'yes' or 'no' (default is 'yes'); checks consistency 
+                         of model
     - restart          : directory name (relative to the execution directory) 
                          where the restart file is located
@@ -54,4 +55,6 @@
     elif solutionstring.lower() == 'mt' or solutionstring.lower() == 'masstransport':
         solutionstring = 'MasstransportSolution'
+    elif solutionstring.lower() == 'oceant' or solutionstring.lower() == 'oceantransport':
+        solutionstring = 'OceantransportSolution'
     elif solutionstring.lower() == 'th' or solutionstring.lower() == 'thermal':
         solutionstring = 'ThermalSolution'
@@ -78,8 +81,8 @@
     elif solutionstring.lower() == 'esa':
         solutionstring = 'EsaSolution'
-    elif solutionstring.lower() == 'slr' or solutionstring.lower() == 'sealevelrise':
-        solutionstring = 'SealevelriseSolution'
+    elif solutionstring.lower() == 'smp' or solutionstring.lower() == 'sampling':
+        solutionstring = 'SamplingSolution'
     else:
-        raise ValueError("solutionstring '%s' not supported!" % solutionstring)
+        raise ValueError('solutionstring {} not supported!'.format(solutionstring))
     options = pairoptions('solutionstring', solutionstring, *args)
 
@@ -98,10 +101,11 @@
         ismodelselfconsistent(md)
 
+    # If we are restarting, actually use the provided runtime name
+    restart = options.getfieldvalue('restart', '')
     # First, build a runtime name that is unique
-    restart = options.getfieldvalue('restart', '')
     if restart == 1:
-        pass  # do nothing
+        pass # Leave the runtimename as is
     else:
-        if restart:
+        if not isempty(restart):
             md.private.runtimename = restart
         else:
@@ -112,5 +116,5 @@
                 md.private.runtimename = md.miscellaneous.name
 
-    # If running QMU analysis, some preprocessing of Dakota files using models 
+    # If running QMU analysis, some preprocessing of Dakota files using model 
     # fields needs to be carried out
     if md.qmu.isdakota:
@@ -127,17 +131,17 @@
     cluster.BuildQueueScript(md.private.runtimename, md.miscellaneous.name, md.private.solution, md.settings.io_gather, md.debug.valgrind, md.debug.gprof, md.qmu.isdakota, md.transient.isoceancoupling) # queue file
 
-    # Stop here if batch mode
-    if options.getfieldvalue('batch', 'no') == 'yes':
-        print('batch mode requested: not launching job interactively')
-        print('launch solution sequence on remote cluster by hand')
-        return md
+    # Upload all required files
+    modelname = md.miscellaneous.name
+    filelist = [modelname + '.bin', modelname + '.toolkits']
 
-    # Upload all required files:
-    modelname = md.miscellaneous.name
-    filelist = [modelname + '.bin ', modelname + '.toolkits ', modelname + '.queue ']
+    if ispc():
+        filelist.append(modelname + '.bat')
+    else:
+        filelist.append(modelname + '.queue')
+
     if md.qmu.isdakota:
         filelist.append(modelname + '.qmu.in')
-        
-    if not restart:
+
+    if isempty(restart):
         cluster.UploadQueueJob(md.miscellaneous.name, md.private.runtimename, filelist)
 
@@ -145,13 +149,20 @@
     cluster.LaunchQueueJob(md.miscellaneous.name, md.private.runtimename, filelist, restart, batch)
 
+    # Return if batch
+    if batch:
+        if md.verbose.solution:
+            print('batch mode requested: not launching job interactively')
+            print('launch solution sequence on remote cluster by hand')
+        return md
+
     # Wait on lock
     if md.settings.waitonlock > 0:
-        islock = waitonlock(md)
-        if islock == 0:  # no results to be loaded
-            print('The results must be loaded manually with md = loadresultsfromcluster(md).')
-        else:  # load results
-            if md.verbose.solution:
-                print('loading results from cluster')
-            md = loadresultsfromcluster(md)
+        # Wait for done file
+        done = waitonlock(md)
+        if md.verbose.solution:
+            print('loading results from cluster')
+        md = loadresultsfromcluster(md)
+    elif md.settings.waitonlock == 0:
+        print('Model results must be loaded manually with md = loadresultsfromcluster(md).')
 
     return md
Index: issm/trunk/src/m/solve/solveslm.m
===================================================================
--- issm/trunk/src/m/solve/solveslm.m	(revision 25994)
+++ issm/trunk/src/m/solve/solveslm.m	(revision 26744)
@@ -1,23 +1,20 @@
 function slm=solveslm(slm,solutionstringi,varargin)
-%SOLVESLR - apply solution sequence for this sealevel model
+%SOLVESLM - apply solution sequence for this sealevel model
 %
 %   Usage:
-%      slm=solve(slm,solutionstring,varargin)
+%      slm=solveslm(slm,solutionstring,varargin)
 %      where varargin is a lit of paired arguments of string OR enums
 %
 %   solution types available comprise:
-%      - 'Sealevelrise'
 %      - 'Transient'
 %
-%  extra options:
+%   extra options:
 %
 %   Examples:
-%      slm=solve(slm,'Transient');
+%      slm=solveslm(slm,'Transient');
 
 %recover and process solve options
 if strcmpi(solutionstringi,'tr') || strcmpi(solutionstringi,'Transient')
 	solutionstring = 'TransientSolution';
-elseif strcmpi(solutionstringi,'slr') || strcmpi(solutionstringi,'Sealevelrise')
-	solutionstring = 'SealevelriseSolution';
 else
 	error(['solutionstring ' solutionstringi ' not supported!']);
@@ -46,5 +43,5 @@
 cluster=slm.cluster;
 batch=0;
-%now, go through icecaps, glacies and earth, and upload all the data independently: 
+%now, go through icecaps, glaciers and earth, and upload all the data independently: 
 disp('solving ice caps first');
 for i=1:length(slm.icecaps),
@@ -54,5 +51,5 @@
 slm.earth=solve(slm.earth,solutionstringi,'batch','yes');
 
-%Firs, build a runtime name that is unique
+%First, build a runtime name that is unique
 c=clock;
 slm.private.runtimename=sprintf('%s-%02i-%02i-%04i-%02i-%02i-%02i-%i',slm.miscellaneous.name,c(2),c(3),c(1),c(4),c(5),floor(c(6)),feature('GetPid'));
Index: issm/trunk/src/m/solve/solveslm.py
===================================================================
--- issm/trunk/src/m/solve/solveslm.py	(revision 26744)
+++ issm/trunk/src/m/solve/solveslm.py	(revision 26744)
@@ -0,0 +1,98 @@
+from datetime import datetime
+import os
+
+import numpy as np
+
+from loadresultsfromcluster import loadresultsfromcluster
+from pairoptions import pairoptions
+from waitonlock import waitonlock
+
+
+def solveslm(slm, solutionstringi, *args):
+    """SOLVESLM - apply solution sequence for this sealevel model
+
+    Usage:
+        slm=solveslm(slm,solutionstring,varargin)
+        where varargin is a lit of paired arguments of string OR enums
+
+    solution types available comprise:
+        - 'Transient'
+
+    extra options:
+
+    Examples:
+        slm=solveslm(slm,'Transient');
+    """
+
+    print('Yep')
+    exit()
+
+    # Recover and process solve options
+    if solutionstringi.lower() == 'tr' or solutionstringi.lower() == 'transient':
+        solutionstring = 'TransientSolution'
+    else:
+        raise RuntimeError('solutionstring {} not supported!'.format(solutionstringi))
+
+    # Default settings for debugging
+    valgrind = 0
+    #slm.cluster.interactive = 0
+    #valgrind = 1
+
+    # Check consistency
+    slm.checkconsistency(solutionstring)
+
+    # Process options
+    options = pairoptions('solutionstring', solutionstring, *args)
+
+    # Make sure we request sum of cluster processors
+    totalnp = 0
+    for i in range(len(slm.icecaps)):
+        totalnp = totalnp + slm.icecaps[i].cluster.np
+    totalnp = totalnp + slm.earth.cluster.np
+    if totalnp != slm.cluster.np:
+        raise RuntimeError('sum of all icecaps and earch cluster processors requestes should be equal to slm.cluster.np')
+
+    # Recover some fields
+    slm.private.solution = solutionstring
+    cluster = slm.cluster
+    batch = 0
+    # Now, go through icecaps, glaciers and earth, and upload all the data independently
+    print('solving ice caps first')
+    for i in range(len(slm.icecaps)):
+        slm.icecaps[i] = solve(slm.icecaps[i], solutionastringi,'batch','yes')
+    print('solving earth now')
+    slm.earth = solve(slm.earth, solutionstringi, 'batch', 'yes')
+
+    # First, build a runtime name that is unique
+    c = datetime.now()
+    md.private.runtimename = "%s-%02i-%02i-%04i-%02i-%02i-%02i-%i" % (md.miscellaneous.name, c.month, c.day, c.year, c.hour, c.minute, c.second, os.getpid())
+
+    # Write all input files
+    privateruntimenames = []
+    miscellaneousnames = []
+    nps = []
+    for i in range(len(slm.icecaps)):
+        privateruntimenames.append(slm.icecaps[i],private.runtimename)
+        miscellaneousnames.append(slm.earth.miscellaneous.name)
+        nps.append(slm.earth.cluster.np)
+
+    BuildQueueScriptMultipleModels(cluster, slm.private.runtimename, slm.miscellaneous.name, slm.private.solution, valgrind, privateruntimenames, miscellaneousnames, nps)
+
+    # Upload all required files, given that each individual solution for icecaps and earth model already did
+    filelist = [slm.miscellaneous.name + '.queue']
+    UploadQueueJob(cluster, slm.miscellaneous.name, slm.private.runtimename, filelist)
+
+    # Launch queue job
+    LaunchQueueJob(cluster, slm.miscellaneous.name, slm.private.runtimename, filelist, '', batch)
+
+    # Wait on lock
+    if slm.settings.waitonlock > 0:
+        islock = waitonlock(slm)
+        if islock == 0:  # no results to be loaded
+            print('The results must be loaded manually with md = loadresultsfromcluster(md).')
+        else: # load results
+            if slm.verbose.solution:
+                print('loading results from cluster')
+            slm = loadresultsfromcluster(slm)
+
+    return slm
Index: issm/trunk/src/m/solve/waitonlock.m
===================================================================
--- issm/trunk/src/m/solve/waitonlock.m	(revision 25994)
+++ issm/trunk/src/m/solve/waitonlock.m	(revision 26744)
@@ -2,7 +2,8 @@
 %WAITONLOCK - wait for a file
 %
-%   This routine will return when a file named 'lockfilename' is written to disk.
-%   Also check for outlog file be cause it might bewritten several seconds
-%   after the lock file.
+%   This routine will return when a file named 'lockfilename' is written to 
+%   disk. Also check for outlog file be cause it might be written several 
+%   seconds after the lock file.
+%
 %   If the time limit given in input is exceeded, return 0
 %
@@ -37,5 +38,5 @@
 
 %initialize time and file presence test flag
-time=0; ispresent=0; time0=clock;
+elapsedtime=0; ispresent=0; starttime=clock;
 disp(['waiting for ' lockfilename ' hold on... (Ctrl+C to exit)'])
 
@@ -58,14 +59,14 @@
 
 %loop till file .lock exist or time is up
-while (ispresent==0 & time<timelimit)
+while (ispresent==0 & elapsedtime<timelimit)
 	if strcmpi(oshostname(),cluster.name),
 		pause(1);
 		ispresent=(exist(lockfilename,'file') & exist(logfilename,'file'));
-		time=etime(clock,time0)/60;
+		elapsedtime=etime(clock,starttime)/60;
 	else
 		pause(5);
-		time=etime(clock,time0);
-		fprintf('\rchecking for job completion (time: %i min %i sec)      ',floor(time/60),floor(rem(time,60)));
-		time=time/60; %converts time from sec to min
+		elapsedtime=etime(clock,starttime);
+		fprintf('\rchecking for job completion (time: %i min %i sec)      ',floor(elapsedtime/60),floor(rem(elapsedtime,60)));
+		elapsedtime=elapsedtime/60; %converts time from sec to min
 		ispresent=~system(command);
 		if ispresent, fprintf('\n'); end
@@ -74,5 +75,5 @@
 
 %build output
-if (time>timelimit),
+if (elapsedtime>timelimit),
 	disp('Time limit exceeded. Increase md.settings.waitonlock');
 	disp('The results must be loaded manually with md=loadresultsfromcluster(md).');
Index: issm/trunk/src/m/solve/waitonlock.py
===================================================================
--- issm/trunk/src/m/solve/waitonlock.py	(revision 25994)
+++ issm/trunk/src/m/solve/waitonlock.py	(revision 26744)
@@ -1,62 +1,99 @@
-import os
-from socket import gethostname
+import subprocess
+import sys
 import time
-import MatlabFuncs as m
-
+from generic import *
+from generic_static import *
+# from localpfe import *
+from MatlabFuncs import *
+from pfe import *
 
 def waitonlock(md):
-    """
-    WAITONLOCK - wait for a file
+    """WAITONLOCK - wait for a file
 
-       This routine will return when a file named 'filename' is written to disk.
-       If the time limit given in input is exceeded, return 0
+    This routine will return when a file named 'lockfilename' is written to 
+    disk. Also check for outlog file because it might be written several 
+    seconds after the lock file.
 
-       Usage:
-          flag = waitonlock(md)
+    If the time limit given in input is exceeded, return 0.
+
+    Usage:
+        flag = waitonlock(md)
+
+    TODO:
+    - Uncomment import of localpfe and check on cluster type once localpfe.py 
+    has been translated from localpfe.m.
     """
 
-    #Get filename (lock file) and options
+    # Get lockfilename (lock file) and options
     executionpath = md.cluster.executionpath
-    cluster = md.cluster.name
     timelimit = md.settings.waitonlock
-    filename = os.path.join(executionpath, md.private.runtimename, md.miscellaneous.name + '.lock')
+    cluster = md.cluster
 
-    #waitonlock will work if the lock is on the same machine only:
-    if not m.strcmpi(gethostname(), cluster):
+    if isa(cluster, pfe) and cluster.interactive > 1:
+        lockfilename = '{}/Interactive{}/{}.lock'.format(executionpath, cluster.interactive, md.miscellaneous.name)
+        logfilename = '{}/Interactive{}/{}.outlog'.format(executionpath, cluster.interactive, md.miscellaneous.name)
+    # elif isa(cluster, localpfe):
+    #     lockfilename = '{}/{}.lock'.format(executionpath, md.miscellaneous.name)
+    #     logfilename = '{}/{}.outlog'.format(executionpath, md.miscellaneous.name)
+    else:
+        lockfilename = '{}/{}/{}.lock'.format(executionpath, md.private.runtimename, md.miscellaneous.name)
+        logfilename = '{}/{}/{}.outlog'.format(executionpath, md.private.runtimename, md.miscellaneous.name)
 
-        print('solution launched on remote cluster. log in to detect job completion.')
-        choice = eval(input('Is the job successfully completed? (y / n) '))
-        if not m.strcmp(choice, 'y'):
-            print('Results not loaded... exiting')
-            flag = 0
+    # If we are using the generic cluster in interactive mode, job is already complete
+    if (isa(cluster, generic) and cluster.interactive) or (isa(cluster, generic_static)):
+        # We are in interactive mode, no need to check for job completion
+        return 1
+
+    # Initialize time and file presence test flag
+    elapsedtime = 0
+    ispresent = 0
+    starttime = time.time()
+    print('waiting for {} hold on... (Ctrl+C to exit)'.format(lockfilename))
+
+    # Prepare command if the job is not running on the local machine
+    if not strcmpi(oshostname(), cluster.name):
+        if cluster.name == 'cloud':
+            command = '[ -f {} ] && [ -f {} ] 2>/dev/null'.format(lockfilename, logfilename)
+            command = '{} sshmaster {} --user {} \'{}\''.format(starcluster(), cluster.name, cluster.login, command)
         else:
-            flag = 1
+            command = 'ssh -l {}'.format(cluster.login)
+            if isprop(cluster, 'idfile') and cluster.idfile != '':
+                command += ' -i {}'.format(cluster.idfile)
+            port = 0
+            if isprop(cluster, 'port'):
+                port = cluster.port
+            if port: # Check if port is non-zero
+                command += ' -p {} localhost'.format(port)
+            else:
+                command += ' {}'.format(cluster.name)
+            command += ' "[ -f {} ] && [ -f {} ]" 2>/dev/null'.format(lockfilename, logfilename)
 
-    #job is running on the same machine
-    else:
+    while not ispresent and elapsedtime < timelimit:
+        if strcmpi(oshostname(), cluster.name):
+            pause(1)
+            ispresent = (isfile(lockfilename) and isfile(logfilename))
+            elapsedtime = etime(time.time(), starttime) / 60
+        else:
+            pause(5)
+            elapsedtime = etime(time.time(), starttime)
+            sys.stdout.write('\rchecking for job completion (time: {} min {} sec)      '.format(floor(elapsedtime / 60), floor(rem(elapsedtime, 60)))) # TODO: After Python 2 is deprecated, we can change this call to print([...], end='')
+            elapsedtime = elapsedtime / 60 # Converts time from sec to min
+            subproc = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
+            outs, errs = subproc.communicate() # NOTE: Need to consume output before checking return code
 
-        if 'interactive' in vars(md.cluster) and md.cluster.interactive:
-            #We are in interactive mode, no need to check for job completion
-            flag = 1
-            return flag
-        #initialize time and file presence test flag
-        etime = 0
-        ispresent = 0
-        print(("waiting for '%s' hold on... (Ctrl + C to exit)" % filename))
+            # TODO: Debug the following check under Linux (exits after first iteration with errs = "b")
+            # UPDATE: Works in testing under Debian Linux system. Leaving comment for now so that it is easier to backtrace this issue if someone else encounters it.
+            #
+            #if errs != '':
+            #    raise Exception('waitonlock: check for existence of files failed: {}'.format(errs))
+            ispresent = not subproc.returncode
+            if ispresent:
+                print('')
 
-        #loop till file .lock exist or time is up
-        while ispresent == 0 and etime < timelimit:
-            ispresent = os.path.exists(filename)
-            time.sleep(1)
-            etime += 1 / 60
+    # Build output
+    if elapsedtime > timelimit:
+        print('Time limit exceeded. Increase md.settings.waitonlock')
+        print('The results must be loaded manually with md = loadresultsfromcluster(md).')
+        raise RuntimeError('waitonlock error message: time limit exceeded.')
 
-        #build output
-        if etime > timelimit:
-            print('Time limit exceeded. Increase md.settings.waitonlock')
-            print('The results must be loaded manually with md = loadresultsfromcluster(md).')
-            raise RuntimeError('waitonlock error message: time limit exceeded.')
-            flag = 0
-        else:
-            flag = 1
-
-    return flag
+    return ispresent
Index: issm/trunk/src/m/solvers/asmoptions.m
===================================================================
--- issm/trunk/src/m/solvers/asmoptions.m	(revision 25994)
+++ issm/trunk/src/m/solvers/asmoptions.m	(revision 26744)
@@ -1,4 +1,4 @@
 function asm=asmoptions(varargin)
-%ASMOPTIONS - return Additive Shwartz Method petsc options
+%ASMOPTIONS - return Additive Schwartz Method PETSc options
 %
 %   Usage:
Index: issm/trunk/src/m/solvers/asmoptions.py
===================================================================
--- issm/trunk/src/m/solvers/asmoptions.py	(revision 25994)
+++ issm/trunk/src/m/solvers/asmoptions.py	(revision 26744)
@@ -1,24 +1,27 @@
+from collections import OrderedDict
 from pairoptions import pairoptions
 
+def asmoptions(*args):
+    """ASMOPTIONS - Return Additive Schwartz Method PETSc options
 
-def asmoptions(*args):
-    #ASMOPTIONS - return ASM petsc options
-    #
-    #   Usage:
-    #      options = asmoptions
+    Usage:
+        options = asmoptions
+    """
 
-    #retrieve options provided in *args
+    # Retrieve options provided in *args
     arguments = pairoptions(*args)
 
-    options = [['toolkit', 'petsc'],
-               ['mat_type', 'mpiaij'],
-               ['ksp_type', 'gmres'],
-               ['pc_type', 'asm'],
-               ['sub_pc_type', 'lu'],
-               ['pc_asm_overlap', 3],
-               ['ksp_max_it', 100],
-               ['ksp_rtol', 1e-30]]
+    options = [
+        ['toolkit', 'petsc'],
+        ['mat_type', 'mpiaij'],
+        ['ksp_type', 'gmres'],
+        ['pc_type', 'asm'],
+        ['sub_pc_type', 'lu'],
+        ['pc_asm_overlap', 3],
+        ['ksp_max_it', 100],
+        ['ksp_rtol', 1e-30]
+    ]
 
-    #now, go through our arguments, and write over default options.
+    # Now, go through our arguments, and write over default options
     for i in range(len(arguments.list)):
         arg1 = arguments.list[i][0]
@@ -33,5 +36,10 @@
                 break
         if not found:
-            #this option did not exist, add it:
+            # This option did not exist; add it
             options.append([arg1, arg2])
-    return options
+
+    asmoptions = OrderedDict()
+    for j in range(len(options)):
+        asmoptions[options[j][0]]=options[j][1]
+
+    return asmoptions
Index: issm/trunk/src/m/solvers/asmstokesoptions.m
===================================================================
--- issm/trunk/src/m/solvers/asmstokesoptions.m	(revision 26744)
+++ issm/trunk/src/m/solvers/asmstokesoptions.m	(revision 26744)
@@ -0,0 +1,20 @@
+function asm=asmstokesoptions(varargin)
+%ASMSTOKESOPTIONS - return Additive Schwartz Method Stokes PETSc options
+%
+%   Usage:
+%      options=asmstokesoptions;
+
+%retrieve options provided in varargin
+options=pairoptions(varargin{:});
+asm=struct();
+
+%default asm options
+asm.toolkit='petsc';
+asm.mat_type=getfieldvalue(options,'mat_type','mpiaij');
+asm.ksp_type=getfieldvalue(options,'ksp_type','gmres');
+asm.pc_type=getfieldvalue(options,'pc_type','asm');
+asm.sub_pc_type=getfieldvalue(options,'sub_pc_type','lu');
+asm.pc_asm_overlap=getfieldvalue(options,'pc_asm_overlap',1); % COMSOL's default
+asm.ksp_max_it=getfieldvalue(options,'ksp_max_it',100);
+asm.ksp_rtol=getfieldvalue(options,'ksp_rtol',1e-7);  %tuned for best performance and to fit ISMIP-HOM-C 5km with MUMPS
+asm.ksp_atol=getfieldvalue(options,'ksp_atol',1e-10); %tuned for best performance and to fit ISMIP-HOM-C 5km with MUMPS
Index: issm/trunk/src/m/solvers/asmstokesoptions.py
===================================================================
--- issm/trunk/src/m/solvers/asmstokesoptions.py	(revision 26744)
+++ issm/trunk/src/m/solvers/asmstokesoptions.py	(revision 26744)
@@ -0,0 +1,46 @@
+from collections import OrderedDict
+from pairoptions import pairoptions
+
+def asmstokesoptions(*args):
+    """ASMSTOKESOPTIONS - Return Additive Schwartz Method Stokes PETSc options
+
+    Usage:
+        options = asmstokesoptions
+    """
+
+    # Retrieve options provided in *args
+    arguments = pairoptions(*args)
+
+    options = [
+        ['toolkit', 'petsc'],
+        ['mat_type', 'mpiaij'],
+        ['ksp_type', 'gmres'],
+        ['pc_type', 'asm'],
+        ['sub_pc_type', 'lu'],
+        ['pc_asm_overlap', 1], # COMSOL's default
+        ['ksp_max_it', 100],
+        ['ksp_rtol', 1e-7], # Tuned for best performance and to fit ISMIP-HOM-C 5km with MUMPS
+        ['ksp_atol', 1e-10] # Tuned for best performance and to fit ISMIP-HOM-C 5km with MUMPS
+    ]
+
+    # Now, go through our arguments, and write over default options
+    for i in range(len(arguments.list)):
+        arg1 = arguments.list[i][0]
+        arg2 = arguments.list[i][1]
+        found = 0
+        for j in range(len(options)):
+            joption = options[j][0]
+            if joption == arg1:
+                joption[1] = arg2
+                options[j] = joption
+                found = 1
+                break
+        if not found:
+            # This option did not exist; add it
+            options.append([arg1, arg2])
+
+    asmoptions = OrderedDict()
+    for j in range(len(options)):
+        asmoptions[options[j][0]]=options[j][1]
+
+    return asmoptions
Index: issm/trunk/src/m/solvers/mumpsnoneoptions.py
===================================================================
--- issm/trunk/src/m/solvers/mumpsnoneoptions.py	(revision 25994)
+++ issm/trunk/src/m/solvers/mumpsnoneoptions.py	(revision 26744)
@@ -1,4 +1,5 @@
 from pairoptions import pairoptions
 from collections import OrderedDict
+from IssmConfig import IssmConfig
 
 
@@ -14,27 +15,25 @@
 
     #default mumps options
-    PETSC_MAJOR = IssmConfig('_PETSC_MAJOR_')
-    PETSC_MINOR = IssmConfig('_PETSC_MINOR_')
+    PETSC_MAJOR = IssmConfig('_PETSC_MAJOR_')[0]
+    PETSC_MINOR = IssmConfig('_PETSC_MINOR_')[0]
     if PETSC_MAJOR == 2:
-        mumps.toolkit = 'petsc'
-        mumps.mat_type = getfieldvalue(options, 'mat_type', 'aijmumps')
-        mumps.ksp_type = getfieldvalue(options, 'ksp_type', 'preonly')
-        mumps.pc_type = getfieldvalue(options, 'pc_type', 'lu')
-        mumps.mat_mumps_icntl_14 = getfieldvalue(options, 'mat_mumps_icntl_14', 120)
-    end
+        mumps['toolkit'] = 'petsc'
+        mumps['mat_type'] = options.getfieldvalue(options, 'mat_type', 'aijmumps')
+        mumps['ksp_type'] = options.getfieldvalue(options, 'ksp_type', 'preonly')
+        mumps['pc_type'] = options.getfieldvalue(options, 'pc_type', 'lu')
+        mumps['mat_mumps_icntl_14'] = options.getfieldvalue(options, 'mat_mumps_icntl_14', 120)
 
     if PETSC_MAJOR == 3:
-        mumps.toolkit = 'petsc'
-        mumps.mat_type = getfieldvalue(options, 'mat_type', 'mpiaij')
-        mumps.ksp_type = getfieldvalue(options, 'ksp_type', 'preonly')
-        mumps.pc_type = getfieldvalue(options, 'pc_type', 'lu')
+        mumps['toolkit'] = 'petsc'
+        mumps['mat_type'] = options.getfieldvalue(options, 'mat_type', 'mpiaij')
+        mumps['ksp_type'] = options.getfieldvalue(options, 'ksp_type', 'preonly')
+        mumps['pc_type'] = options.getfieldvalue(options, 'pc_type', 'lu')
         if PETSC_MINOR > 8:
-            mumps.pc_factor_mat_solver_type = getfieldvalue(options, 'pc_factor_mat_solver_type', 'mumps')
+            mumps['pc_factor_mat_solver_type'] = options.getfieldvalue(options, 'pc_factor_mat_solver_type', 'mumps')
         else:
-            mumps.pc_factor_mat_solver_package = getfieldvalue(options, 'pc_factor_mat_solver_package', 'mumps')
-        end
-        mumps.mat_mumps_icntl_14 = getfieldvalue(options, 'mat_mumps_icntl_14', 120)
-        mumps.mat_mumps_icntl_28 = 2; #1 = serial, 2 = parallel
-        mumps.mat_mumps_icntl_29 = 2; #parallel ordering 1 = ptscotch, 2 = parmetis
-    end
-    return solverOptions
+            mumps['pc_factor_mat_solver_package'] = options.getfieldvalue(options, 'pc_factor_mat_solver_package', 'mumps')
+        mumps['mat_mumps_icntl_14'] = options.getfieldvalue(options, 'mat_mumps_icntl_14', 120)
+        mumps['mat_mumps_icntl_28'] = 2  #1 = serial, 2 = parallel
+        mumps['mat_mumps_icntl_29'] = 2  #parallel ordering 1 = ptscotch, 2 = parmetis
+
+    return mumps
Index: issm/trunk/src/m/solvers/mumpsoptions.js
===================================================================
--- issm/trunk/src/m/solvers/mumpsoptions.js	(revision 26744)
+++ issm/trunk/src/m/solvers/mumpsoptions.js	(revision 26744)
@@ -0,0 +1,25 @@
+function mumpsoptions(){
+//MUMPSOPTIONS - 
+//
+//   Usage:
+//      options=mumpsoptions(varargin);
+
+	//Retrieve options provided in varargin. First convert arguments to array:
+	var args = Array.prototype.slice.call(arguments);
+
+	//Then process options
+	var  options = new pairoptions(args.slice(1,args.length));
+
+	//default issmoptions options
+	var mumpsoptions={};
+	mumpsoptions['toolkit']='petsc';
+	mumpsoptions['mat_type']=options.getfieldvalue('mat_type','mpiaij');
+	mumpsoptions['ksp_type']=options.getfieldvalue('ksp_type','preonly');
+	mumpsoptions['pc_type']=options.getfieldvalue('pc_type','lu');
+	mumpsoptions['pc_factor_mat_solver_type']=options.getfieldvalue('pc_factor_mat_solver_type','mumps');
+	mumpsoptions['mat_mumps_icntl_14']=options.getfieldvalue('mat_mumps_icntl_14',120);
+	mumpsoptions['mat_mumps_icntl_28']=options.getfieldvalue('mat_mumps_icntl_28',2);
+	mumpsoptions['mat_mumps_icntl_29']=options.getfieldvalue('mat_mumps_icntl_29',2);
+
+	return mumpsoptions;
+}
Index: issm/trunk/src/m/solvers/mumpsoptions.py
===================================================================
--- issm/trunk/src/m/solvers/mumpsoptions.py	(revision 25994)
+++ issm/trunk/src/m/solvers/mumpsoptions.py	(revision 26744)
@@ -1,4 +1,4 @@
 from collections import OrderedDict
-import pairoptions
+from pairoptions import pairoptions
 from IssmConfig import IssmConfig
 
@@ -13,5 +13,5 @@
 
     #retrieve options provided in varargin
-    options = pairoptions.pairoptions(*args)
+    options = pairoptions(*args)
     mumps = OrderedDict()
 
@@ -24,5 +24,5 @@
         mumps['ksp_type'] = options.getfieldvalue('ksp_type', 'preonly')
         mumps['pc_type'] = options.getfieldvalue('pc_type', 'lu')
-        mumps['mat_mumps_icntl_14'] = options.getfieldvalue('mat_mumps_icntl_14', 120)
+        mumps['mat_mumps_icntl_14'] = options.options.getfieldvalue('mat_mumps_icntl_14', 120)
     if PETSC_MAJOR == 3.:
         mumps['toolkit'] = 'petsc'
@@ -36,3 +36,7 @@
         mumps['mat_mumps_icntl_14'] = options.getfieldvalue('mat_mumps_icntl_14', 120)
 
+        #These 2 lines make raijin break (ptwgts error during solver with PETSc 3.3)
+        mumps['mat_mumps_icntl_28'] = options.getfieldvalue('mat_mumps_icntl_28', 1)  #1=serial, 2=parallel
+        mumps['mat_mumps_icntl_29'] = options.getfieldvalue('mat_mumps_icntl_29', 2)  #parallel ordering 1 = ptscotch, 2 = parmetis
+
     return mumps
